## ros-humble-rcl 5.3.8

=== debian/changelog ===
ros-humble-rcl (5.3.8-1bookworm) bookworm; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 14 May 2024 16:00:00 -0000

ros-humble-rcl (5.3.7-1bookworm) bookworm; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 23 Jan 2024 16:00:00 -0000

ros-humble-rcl (5.3.6-1bookworm) bookworm; urgency=high

  * Set disable loan to on by default. (backport #1110 <https://github.com/ros2/rcl/issues/1110>) (#1116 <https://github.com/ros2/rcl/issues/1116>)
  * Contributors: mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Sun, 12 Nov 2023 16:00:00 -0000

ros-humble-rcl (5.3.5-1bookworm) bookworm; urgency=high

  * rcl_send_response returns RCL_RET_TIMEOUT. (backport #1048 <https://github.com/ros2/rcl/issues/1048>) (#1091 <https://github.com/ros2/rcl/issues/1091>)
  * Contributors: mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 18 Sep 2023 16:00:00 -0000

ros-humble-rcl (5.3.4-1bookworm) bookworm; urgency=high

  * Implement rcl_clock_time_started (#1021 <https://github.com/ros2/rcl/issues/1021>) (#1078 <https://github.com/ros2/rcl/issues/1078>)
  * Contributors: mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Sun, 16 Jul 2023 16:00:00 -0000

ros-humble-rcl (5.3.3-1bookworm) bookworm; urgency=high

  * user defined allocator should be used for rosout publisher. (#1044 <https://github.com/ros2/rcl/issues/1044>) (#1045 <https://github.com/ros2/rcl/issues/1045>)
  * avoid unnecessary copy for rcutils_char_array_vsprintf. (#1035 <https://github.com/ros2/rcl/issues/1035>) (#1039 <https://github.com/ros2/rcl/issues/1039>)
  * Contributors: mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 24 Apr 2023 16:00:00 -0000

ros-humble-rcl (5.3.2-1bookworm) bookworm; urgency=high

  * fixed rcl_wait return error when timer cancelled (#1003 <https://github.com/ros2/rcl/issues/1003>) (#1006 <https://github.com/ros2/rcl/issues/1006>)
  * Contributors: mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 07 Sep 2022 16:00:00 -0000

ros-humble-rcl (5.3.1-1bookworm) bookworm; urgency=high

  * Fix buffer overflow in argument parsing caused by lexer returning length beyond length of string (#979 <https://github.com/ros2/rcl/issues/979>)
  * Fix leak in test_subscription_content_filter_options.cpp (#978 <https://github.com/ros2/rcl/issues/978>)
  * Contributors: Shane Loretz

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 25 Apr 2022 16:00:00 -0000

ros-humble-rcl (5.3.0-1bookworm) bookworm; urgency=high

  * add content-filtered-topic interfaces (#894 <https://github.com/ros2/rcl/issues/894>)
  * Contributors: Chen Lihui

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 04 Apr 2022 16:00:00 -0000

ros-humble-rcl (5.2.1-1bookworm) bookworm; urgency=high

  * Add additional null check for timer argument (#973 <https://github.com/ros2/rcl/issues/973>)
  * Contributors: NoyZuberi

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 30 Mar 2022 16:00:00 -0000

ros-humble-rcl (5.2.0-1bookworm) bookworm; urgency=high

  * Allow forward slashes within a parameter name rule in argument parsing (#860 <https://github.com/ros2/rcl/issues/860>)
  * Suppress false positive from clang-tidy (#951 <https://github.com/ros2/rcl/issues/951>)
  * Fix missing terminating 0 in rcl_context_impl_t.argv (#969 <https://github.com/ros2/rcl/issues/969>)
  * test_publisher_wait_all_ack depends on rcpputils (#968 <https://github.com/ros2/rcl/issues/968>)
  * Micro-optimizations in rcl (#965 <https://github.com/ros2/rcl/issues/965>)
  * If timer canceled, rcl_timer_get_time_until_next_call returns TIMER_CANCELED (#963 <https://github.com/ros2/rcl/issues/963>)
  * Contributors: Chris Lalancette, Haowei Wen, Ivan Santiago Paunovic, Shane Loretz, William Woodall, mauropasse

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 23 Mar 2022 16:00:00 -0000

ros-humble-rcl (5.1.0-1bookworm) bookworm; urgency=high

  * Add Events Executor (#839 <https://github.com/ros2/rcl/issues/839>)
  * Remove fastrtps customization on test_events (#960 <https://github.com/ros2/rcl/issues/960>)
  * Add client/service QoS getters (#941 <https://github.com/ros2/rcl/issues/941>)
  * introduce ROS_DISABLE_LOAN_MSG to disable can_loan_messages. (#949 <https://github.com/ros2/rcl/issues/949>)
  * Install includes it include/${PROJECT_NAME} (#959 <https://github.com/ros2/rcl/issues/959>)
  * Contributors: Miguel Company, Shane Loretz, Tomoya Fujita, iRobot ROS, mauropasse

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 28 Feb 2022 16:00:00 -0000

ros-humble-rcl (5.0.1-1bookworm) bookworm; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 13 Jan 2022 16:00:00 -0000

ros-humble-rcl (5.0.0-1bookworm) bookworm; urgency=high

  * Make rcl_difference_times args const (#955 <https://github.com/ros2/rcl/issues/955>)
  * Update inject_on_return test skipping logic (#953 <https://github.com/ros2/rcl/issues/953>)
  * Fix jump callbacks being called when zero time jump thresholds used (#948 <https://github.com/ros2/rcl/issues/948>)
  * Only change the default logger level if default_logger_level is set (#943 <https://github.com/ros2/rcl/issues/943>)
  * Add Library for wait_for_entity_helpers to deduplicate compilation (#942 <https://github.com/ros2/rcl/issues/942>)
  * Increase Windows timeout 15 -> 25 ms (#940 <https://github.com/ros2/rcl/issues/940>)
  * test should check specified number of entities. (#935 <https://github.com/ros2/rcl/issues/935>)
  * Contributors: Jafar Abdi, Scott K Logan, Shane Loretz, Tomoya Fujita

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 13 Dec 2021 16:00:00 -0000

ros-humble-rcl (4.0.0-1bookworm) bookworm; urgency=high

  * Fix up documentation build for rcl when using rosdoc2 (#932 <https://github.com/ros2/rcl/issues/932>)
  * Include rmw_event_t instead of forward declaring it (#933 <https://github.com/ros2/rcl/issues/933>)
  * Contributors: Michel Hidalgo


